package rwpbb.example.panoamarino;



import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnKeyListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ProgressBar;

import android.widget.TextView;
import at.abraxas.amarino.Amarino;
import at.abraxas.amarino.AmarinoIntent;


        public class PanoAmarino extends Activity {
        	/* TODO: изменяем на адрес используемого Bluetooth модуля
        	 * and ensure your device is added to Amarino
        	 */
        	private static final String DEVICE_ADDRESS = "00:11:09:09:02:51";	
        	
        	ProgressBar redSB;
        	//TextView indik1;
        	CheckBox checkboxO;
        	TextView indik2;
        	TextView indik3;
        	Button buttont;//Кнопка передающая данные Arduino  под флагом 't'
        	Button buttons;
        	Button buttonr;
        	Button buttonq;
        	Button buttonp;
        	Button buttono;
        	EditText param1;
        	EditText param2;
        	EditText param3;
        	int fo, fp, fq, fr, fs, ft, fk, fl;//переменные передаваемые Arduino  под соответствующими названию флагами т.е. 'fo' соответствует флагу 'o' итд
        	int h1=0;
        	int dh1=10;
        	int dh2=3;
        	int dh3=4;
        	String sh1;
        	String flagR ="C";
        	private ArduinoReceiver arduinoReceiver = new ArduinoReceiver();
        	/** Called when the activity is first created. */
            @Override
           
            public void onCreate(Bundle savedInstanceState) {
                super.onCreate(savedInstanceState);
                setContentView(R.layout.main);
                
             // in order to receive broadcasted intents we need to register our receiver
        		registerReceiver(arduinoReceiver, new IntentFilter(AmarinoIntent.ACTION_RECEIVED));
                Amarino.connect(this, DEVICE_ADDRESS);
             // Привязка к графическим элеменетам интерфейса в файле 'res/layout/main.xml'
                redSB = (ProgressBar) findViewById(R.id.progressBar1);
                //indik1 = (TextView) findViewById(R.id.textView1);
                checkboxO = (CheckBox) findViewById(R.id.checkBox1);
                indik2 = (TextView) findViewById(R.id.textView2);
                indik3 = (TextView) findViewById(R.id.textView3);
                buttont = (Button) findViewById(R.id.button1);//Пуск
                buttons = (Button) findViewById(R.id.button2);//Верх
                buttonr = (Button) findViewById(R.id.button3);//Лево
                buttonq = (Button) findViewById(R.id.button4);//Право
                buttonp = (Button) findViewById(R.id.button5);//Низ
                buttono = (Button) findViewById(R.id.button6);//Затвор
                param1 = (EditText) findViewById(R.id.editText1);
                param2 = (EditText) findViewById(R.id.editText2);
                param3 = (EditText) findViewById(R.id.editText3);
                
                String sdh1 = String.valueOf(dh1);//Преобразуем int в String
                param1.setText(sdh1);
                String sdh2 = String.valueOf(dh2);//Преобразуем int в String
                param2.setText(sdh2);
                String sdh3 = String.valueOf(dh3);//Преобразуем int в String
                param3.setText(sdh3);
                
                buttono.setOnClickListener(new OnClickListener() {
                    public void onClick(View v) {
                        // Действие при нажатии на кнопку
                    	fk = dh2;
                    	updateFk();
                    
                    	fo = dh3;
        				updateFo();
                     
                    }					
                });
                
                buttonp.setOnClickListener(new OnClickListener() {
                    public void onClick(View v) {
                        // Действие при нажатии на кнопку
                    	fp = dh1;
        				updateFp();
                     
                    }					
                });
                
                buttons.setOnClickListener(new OnClickListener() {
                    public void onClick(View v) {
                        // Действие при нажатии на кнопку
                    	fs = dh1;
        				updateFs();
                     
                    }					
                });
                
                buttont.setOnClickListener(new OnClickListener() {
                    public void onClick(View v) {
                        // Действие при нажатии на кнопку
                    	fk = dh2;
                    	updateFk();
                    	ft = dh3;       				
        				updateFt();
                     
                    }					
                });
                
                buttonq.setOnClickListener(new OnClickListener() {
                    public void onClick(View v) {
                        // Perform action on clicks
                       h1=h1+dh1; 
                       //redSB.setProgress(h1);
                       //String sh1 = String.valueOf(h1);
                       //indik1.setText(sh1);
                       fq = dh1;
       				   updateFq();
                    }					
                });
                    
                    buttonr.setOnClickListener(new OnClickListener() {
                        public void onClick(View v) {
                            // Perform action on clicks
                           h1=h1-dh1; 
                     
                           fr = dh1;
           				   updateFr();
                    }
                });
                    param1.setOnKeyListener(new OnKeyListener() {
                        public boolean onKey(View v, int keyCode, KeyEvent event) {
                            // If the event is a key-down event on the "enter" button
                            if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
                                (keyCode == KeyEvent.KEYCODE_ENTER)) {
                              // Perform action on key press
                              String sh3 = param1.getText().toString();                              
                              dh1= Integer.parseInt(sh3);//Преобразуем String в int
                              return true;
                            }
                            return false;
                        }
                    });
                    param2.setOnKeyListener(new OnKeyListener() {
                        public boolean onKey(View v, int keyCode, KeyEvent event) {
                            // If the event is a key-down event on the "enter" button
                            if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
                                (keyCode == KeyEvent.KEYCODE_ENTER)) {
                              // Perform action on key press
                              String sh3 = param2.getText().toString();                              
                              dh2= Integer.parseInt(sh3);//Преобразуем String в int
                              return true;
                            }
                            return false;
                        }
                    });
                    param3.setOnKeyListener(new OnKeyListener() {
                        public boolean onKey(View v, int keyCode, KeyEvent event) {
                            // If the event is a key-down event on the "enter" button
                            if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
                                (keyCode == KeyEvent.KEYCODE_ENTER)) {
                              // Perform action on key press
                              String sh3 = param3.getText().toString();                              
                              dh3= Integer.parseInt(sh3);//Преобразуем String в int
                              return true;
                            }
                            return false;
                        }
                    });
                    checkboxO.setOnClickListener(new OnClickListener() {
                        public void onClick(View v) {
                            // Perform action on clicks, depending on whether it's now checked
                            if (((CheckBox) v).isChecked()) {
                            	fl = 1;
                				updateFl();
                            } else {
                            	fl = 0;
             				   updateFl();
                            }
                        }
                    });
    }
            
            @Override
        	protected void onStop() {
        		super.onStop();
        		// stop Amarino's background service, we don't need it any more 
        		Amarino.disconnect(this, DEVICE_ADDRESS);
        		// do never forget to unregister a registered receiver
        		unregisterReceiver(arduinoReceiver);
        	}
            
            private void updateFo(){
        		//Выбираем маленькую букву 'o' для флага и передаем целую переменную 'fo' Arduino
          
        		Amarino.sendDataToArduino(this, DEVICE_ADDRESS, 'o', fo);
        	}
        	
        	private void updateFp(){
        		Amarino.sendDataToArduino(this, DEVICE_ADDRESS, 'p', fp);
        	}
        	
        	private void updateFq(){
        		Amarino.sendDataToArduino(this, DEVICE_ADDRESS, 'q', fq);
        	}
        	
        	private void updateFr(){
        		Amarino.sendDataToArduino(this, DEVICE_ADDRESS, 'r', fr);
        	}
        	
        	private void updateFs(){
        		Amarino.sendDataToArduino(this, DEVICE_ADDRESS, 's', fs);
        	}
        	
        	private void updateFt(){
        		Amarino.sendDataToArduino(this, DEVICE_ADDRESS, 't', ft);
        	}
        	private void updateFk(){
        		Amarino.sendDataToArduino(this, DEVICE_ADDRESS, 'k', fk);
        	}
        	private void updateFl(){
        		Amarino.sendDataToArduino(this, DEVICE_ADDRESS, 'l', fl);
        	}
        	
        	/**
        	 * ArduinoReceiver is responsible for catching broadcasted Amarino
        	 * events.
        	 * 
        	 * It extracts data from the intent and updates the graph accordingly.
        	 */
        	public class ArduinoReceiver extends BroadcastReceiver {

        		@Override
        		public void onReceive(Context context, Intent intent) {
        			String data = null;
        			
        			// the device address from which the data was sent, we don't need it here but to demonstrate how you retrieve it
        			//final String address = intent.getStringExtra(AmarinoIntent.EXTRA_DEVICE_ADDRESS);
        			
        			// the type of data which is added to the intent
        			final int dataType = intent.getIntExtra(AmarinoIntent.EXTRA_DATA_TYPE, -1);
        			
        			// we only expect String data though, but it is better to check if really string was sent
        			// later Amarino will support differnt data types, so far data comes always as string and
        			// you have to parse the data to the type you have sent from Arduino, like it is shown below
        			if (dataType == AmarinoIntent.STRING_EXTRA){
        				data = intent.getStringExtra(AmarinoIntent.EXTRA_DATA);
        				
        				if (data != null){
        					
        					if (flagR.equals("A")){
        						indik2.setText(data);
        						redSB.setProgress(Integer.parseInt(data));
        					}
        					if (flagR.equals("B")){
        						indik3.setText(data);
        						
        					}
        					//flagR = data.substring(0,1);
        					flagR = data;//
        					//mValueTV.setText(data);
        			
//        					try {
//        						// since we know that our string value is an int number we can parse it to an integer
//        						final int sensorReading = Integer.parseInt(data);
//        					//	mGraph.addDataPoint(sensorReading);
//        					} 
//        					catch (NumberFormatException e) { /* oh data was not an integer */ }
        				}
        			}
        		}
        	}
}